#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

struct tree
{
	int num;
	struct tree* left;
	struct tree* right;
};

void init (struct tree** t)
{
	*t = NULL;
}

void set (struct tree** t, int x)
{
	*t = (struct tree*)malloc(sizeof(struct tree));
	(*t)->num = x;
	(*t)->right = NULL;
	(*t)->left = NULL;
}

void add (struct tree** t, int x)
{
	if (*t == NULL)
		set (t, x);
	else if (x < (*t)->num)
		add (&(*t)->left, x);
	else
		add (&(*t)->right, x);
}

void bulid_t (struct tree** t)
{
	int i, x, max;
	max = 1 + random(5);
	for (i = 0; i < max; i++)
	{
		x = random(30);
		add (t,x);
	}
}

void display_t (struct tree* t)
{
	if (t != NULL)
	{
		printf ("%d\t", t->num);
		display_t (t->left);
		display_t (t->right);
	}
	else
		return;
}

int full_bin_t (struct tree** t)
{
	if (((*t)->left == NULL)&& ((*t)->right == NULL))
		return 1;
	else if (((*t)->left == NULL)|| ((*t)->right == NULL))
        	return 0;
	else if (full_bin_t (&(*t)->left) && full_bin_t (&(*t)->right))
		return 1;
	else
		return 0;
}

void del_t (struct tree** t)
{
	if (*t != NULL)
	{
		del_t (&(*t)->left);
		del_t (&(*t)->right);
		printf ("%p\t", *t);
		free (*t);
	}
	else
		return;
}

void main()
{
	struct tree* t;
	randomize();

	init (&t);
	bulid_t (&t);
	display_t (t);
	if (full_bin_t (&t))
		printf ("\nThe tree is a full binary tree\n");
	else
		printf ("\nThe tree is not a full binary tree\n");
	del_t (&t);
}